Index: trunk/src/lib/gui/gl/glgui_handler.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_handler.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_handler.cc	(revision 9869)
@@ -23,5 +23,6 @@
 #include "glgui_cursor.h"
 
-#include "class_list.h"
+#include "loading/resource_manager.h"
+
 #include <cassert>
 
@@ -31,9 +32,8 @@
 /// TAKE THIS OUT OF HERE.
 #include "graphics_engine.h"
-#include "loading/resource_manager.h"
 
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiHandler);
   /**
    * standard constructor
@@ -41,5 +41,5 @@
   GLGuiHandler::GLGuiHandler ()
   {
-    this->setClassID(CL_GLGUI_HANDLER, "GLGuiHandler");
+    this->registerObject(this, GLGuiHandler::_objectList);
     this->setName("GLGuiHandler");
 
@@ -77,5 +77,5 @@
     this->_cursor->setMaxBorders(Vector2D(GraphicsEngine::getInstance()->getResolutionX(), GraphicsEngine::getInstance()->getResolutionY()));
 
-    _cursor->loadTextureSequence(ResourceManager::getInstance()->getDataDir() + "/" + "maps/reap_mouse/reap_mouse_##.png", 1, 49);
+    _cursor->loadTextureSequence(Resources::ResourceManager::getInstance()->mainGlobalPath().name() + "/" + "maps/reap_mouse/reap_mouse_##.png", 1, 49);
 
   }
@@ -117,63 +117,49 @@
   {
     // retrieve Objects.
-    const std::list<BaseObject*>* objects = ClassList::getList(CL_GLGUI_WIDGET);
-
-    if (objects)
-    {
-      std::list<BaseObject*>::const_iterator it ;
-      std::list<BaseObject*>::const_iterator currentIt = objects->end();
+    ObjectList<GLGuiWidget>::const_iterator it, currentIt;
+    currentIt = GLGuiWidget::objectList().end();
+
+    if (GLGuiWidget::selected() != NULL)
+    {
+      it = std::find(GLGuiWidget::objectList().begin(), GLGuiWidget::objectList().end(), GLGuiWidget::selected());
+      if (it != GLGuiWidget::objectList().end())
+      {
+        currentIt = it;
+        it++;
+      }
+    }
+    else
+    {
+      it = GLGuiWidget::objectList().begin();
+    }
+
+    bool cycledOnce = false;
+
+    for (; it != currentIt; ++it)
+    {
+      if (it == GLGuiWidget::objectList().end() && !cycledOnce)
+      {
+        it = GLGuiWidget::objectList().begin();
+        cycledOnce = true;
+      }
+
+      if ((*it)->selectable() && (*it)->isVisible())
+      {
+        (*it)->select();
+        return;
+      }
+    }
+
+  }
+
+  void GLGuiHandler::selectPrevious()
+  {
+    ObjectList<GLGuiWidget>::const_iterator it, currentIt;
+    currentIt = GLGuiWidget::objectList().begin();
 
       if (GLGuiWidget::selected() != NULL)
       {
-        it = std::find(objects->begin(), objects->end(), GLGuiWidget::selected());
-        if (it != objects->end())
-        {
-          currentIt = it;
-          it++;
-        }
-      }
-      else
-      {
-        it = objects->begin();
-      }
-
-      bool cycledOnce = false;
-
-      for (; it != currentIt; ++it)
-      {
-        if (it == objects->end() && !cycledOnce)
-        {
-          it = objects->begin();
-          cycledOnce = true;
-        }
-
-        if (dynamic_cast<GLGuiWidget*>(*it)->selectable() && dynamic_cast<GLGuiWidget*>(*it)->isVisible())
-        {
-          dynamic_cast<GLGuiWidget*>(*it)->select();
-          return;
-        }
-      }
-
-    }
-    else
-    {
-      PRINTF(0)("NO GUI-ELEMENTS EXISTING\n");
-    }
-  }
-
-  void GLGuiHandler::selectPrevious()
-  {
-    // retrieve Objects.
-    const std::list<BaseObject*>* objects = ClassList::getList(CL_GLGUI_WIDGET);
-
-    if (objects)
-    {
-      std::list<BaseObject*>::const_iterator it ;
-      std::list<BaseObject*>::const_iterator currentIt = objects->begin();
-
-      if (GLGuiWidget::selected() != NULL)
-      {
-        it = std::find(objects->begin(), objects->end(), GLGuiWidget::selected());
-        if (it != objects->end())
+	it = std::find(GLGuiWidget::objectList().begin(), GLGuiWidget::objectList().end(), GLGuiWidget::selected());
+	if (it != GLGuiWidget::objectList().end())
         {
           currentIt = it;
@@ -183,5 +169,5 @@
       else
       {
-        it = objects->end();
+	it = GLGuiWidget::objectList().end();
       }
 
@@ -190,5 +176,5 @@
       for (; it != currentIt; --it)
       {
-        if (it == objects->end() && !cycledOnce)
+	if (it == GLGuiWidget::objectList().end() && !cycledOnce)
         {
           --it ;
@@ -196,16 +182,11 @@
         }
 
-        if (dynamic_cast<GLGuiWidget*>(*it)->selectable() && dynamic_cast<GLGuiWidget*>(*it)->isVisible())
-        {
-          dynamic_cast<GLGuiWidget*>(*it)->select();
+        if ((*it)->selectable() && (*it)->isVisible())
+        {
+          (*it)->select();
           return;
         }
       }
 
-    }
-    else
-    {
-      PRINTF(0)("NO GUI-ELEMENTS EXISTING\n");
-    }
   }
 
@@ -217,51 +198,51 @@
     {
       case EV_MOUSE_MOTION:
-        this->checkFocus();
-        break;
+      this->checkFocus();
+      break;
 
       case  EV_MOUSE_BUTTON_LEFT:
-        if (GLGuiWidget::mouseFocused() != NULL && event.bPressed)
-        {
-          // if clickable select the Widget.
-          if (GLGuiWidget::mouseFocused()->clickable())
-          {
-            Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
-            GLGuiWidget::mouseFocused()->select();
-            GLGuiWidget::mouseFocused()->click(cursorPos - GLGuiWidget::mouseFocused()->getAbsCoor2D());
-          }
-        }
-        else if (GLGuiWidget::selected() != NULL && !event.bPressed)
-        {
-          if (GLGuiWidget::selected()->clickable())
-          {
-            Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
-            GLGuiWidget::selected()->release(cursorPos - GLGuiWidget::selected()->getAbsCoor2D());
-          }
-        }
-
-        break;
+      if (GLGuiWidget::mouseFocused() != NULL && event.bPressed)
+      {
+        // if clickable select the Widget.
+        if (GLGuiWidget::mouseFocused()->clickable())
+        {
+          Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
+          GLGuiWidget::mouseFocused()->select();
+          GLGuiWidget::mouseFocused()->click(cursorPos - GLGuiWidget::mouseFocused()->getAbsCoor2D());
+        }
+      }
+      else if (GLGuiWidget::selected() != NULL && !event.bPressed)
+      {
+        if (GLGuiWidget::selected()->clickable())
+        {
+          Vector2D cursorPos = (this->_cursor != NULL) ? this->_cursor->getAbsCoor2D() : Vector2D(event.x, event.y);
+          GLGuiWidget::selected()->release(cursorPos - GLGuiWidget::selected()->getAbsCoor2D());
+        }
+      }
+
+      break;
       case EV_LEAVE_STATE:
-        if (GLGuiWidget::selected() != NULL)
-          GLGuiWidget::selected()->unselect();
-
-        if (GLGuiWidget::mouseFocused() != NULL)
-          GLGuiWidget::mouseFocused()->breakMouseFocus();
-        break;
+      if (GLGuiWidget::selected() != NULL)
+        GLGuiWidget::selected()->unselect();
+
+      if (GLGuiWidget::mouseFocused() != NULL)
+        GLGuiWidget::mouseFocused()->breakMouseFocus();
+      break;
 
       case EV_VIDEO_RESIZE:
-        if (this->_cursor != NULL)
-          this->_cursor->setMaxBorders(Vector2D(event.resize.w, event.resize.h));
-        this->_resolution = Vector2D(event.resize.w, event.resize.h);
-        break;
+      if (this->_cursor != NULL)
+        this->_cursor->setMaxBorders(Vector2D(event.resize.w, event.resize.h));
+      this->_resolution = Vector2D(event.resize.w, event.resize.h);
+      break;
 
       case SDLK_TAB:
-        if (event.bPressed)
-        {
-          if (EventHandler::getInstance()->isPressed(SDLK_LSHIFT) || EventHandler::getInstance()->isPressed(SDLK_RSHIFT))
-            this->selectPrevious();
-          else
-            this->selectNext();
-        }
-        break;
+      if (event.bPressed)
+      {
+        if (EventHandler::getInstance()->isPressed(SDLK_LSHIFT) || EventHandler::getInstance()->isPressed(SDLK_RSHIFT))
+          this->selectPrevious();
+        else
+          this->selectNext();
+      }
+      break;
     }
 
@@ -304,11 +285,11 @@
   {
     // CHECK THE COLLISIONS.
-    const std::list<BaseObject*>* objects = ClassList::getList(CL_GLGUI_WIDGET);
-
-    if (objects != NULL && this->_cursor != NULL)
-    {
-      for (std::list<BaseObject*>::const_iterator it = objects->begin(); it != objects->end(); it++)
-      {
-        GLGuiWidget* widget = dynamic_cast<GLGuiWidget*>(*it);
+    if (this->_cursor != NULL)
+    {
+      for (ObjectList<GLGuiWidget>::const_iterator it = GLGuiWidget::objectList().begin();
+	   it != GLGuiWidget::objectList().end();
+	   it++)
+      {
+        GLGuiWidget* widget = (*it);
 
         if (widget->isVisible() &&
Index: trunk/src/lib/gui/gl/glgui_handler.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_handler.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_handler.h	(revision 9869)
@@ -19,5 +19,5 @@
   class GLGuiHandler : public EventListener
   {
-
+    ObjectListDeclaration(GLGuiHandler);
   public:
     /** @returns a Pointer to the only object of this Class */
Index: trunk/src/lib/gui/gl/glgui_image.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_image.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_image.cc	(revision 9869)
@@ -22,5 +22,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiImage);
   /**
    * standard constructor
@@ -45,5 +45,5 @@
   void GLGuiImage::init()
   {
-    this->setClassID(CL_GLGUI_IMAGE, "GLGuiImage");
+    this->registerObject(this, GLGuiImage::_objectList);
 
     this->setForegroundColor(Color(1,1,1,1));
Index: trunk/src/lib/gui/gl/glgui_image.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_image.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_image.h	(revision 9869)
@@ -21,5 +21,5 @@
   class GLGuiImage : public GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiImage);
   public:
     GLGuiImage();
Index: trunk/src/lib/gui/gl/glgui_inputline.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_inputline.cc	(revision 9869)
@@ -20,4 +20,5 @@
 namespace OrxGui
 {
+  ObjectListDefinition(GLGuiInputLine);
   /**
    * @brief standard constructor
@@ -44,5 +45,5 @@
   void GLGuiInputLine::init()
   {
-    this->setClassID(CL_GLGUI_INPUTLINE, "GLGuiInputLine");
+    this->registerObject(this, GLGuiInputLine::_objectList);
 
     this->setFocusable(true);
Index: trunk/src/lib/gui/gl/glgui_inputline.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_inputline.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_inputline.h	(revision 9869)
@@ -25,5 +25,5 @@
   class GLGuiInputLine : public OrxGui::GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiInputLine);
   public:
     GLGuiInputLine();
Index: trunk/src/lib/gui/gl/glgui_mainwidget.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_mainwidget.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_mainwidget.cc	(revision 9869)
@@ -20,5 +20,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiMainWidget);
 
   /**
@@ -27,5 +27,5 @@
   GLGuiMainWidget::GLGuiMainWidget()
   {
-    this->setClassID(CL_GLGUI_MAIN_WIDGET, "GLGuiMainWidget");
+    this->registerObject(this, GLGuiMainWidget::_objectList);
     this->setName("GLGuiMainWidget");
   }
Index: trunk/src/lib/gui/gl/glgui_mainwidget.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_mainwidget.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_mainwidget.h	(revision 9869)
@@ -15,5 +15,5 @@
   class GLGuiMainWidget : public GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiMainWidget);
   public:
     virtual ~GLGuiMainWidget(void);
Index: trunk/src/lib/gui/gl/glgui_menu.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_menu.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_menu.cc	(revision 9869)
@@ -20,5 +20,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiMenu);
   /**
    * standard constructor
Index: trunk/src/lib/gui/gl/glgui_menu.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_menu.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_menu.h	(revision 9869)
@@ -19,5 +19,5 @@
   class GLGuiMenu : public GLGuiMenu
   {
-
+    ObjectListDeclaration(GLGuiMenu);
   public:
     GLGuiMenu();
Index: trunk/src/lib/gui/gl/glgui_pushbutton.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_pushbutton.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_pushbutton.cc	(revision 9869)
@@ -23,5 +23,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiPushButton);
   /**
    * @brief standard constructor
@@ -58,5 +58,5 @@
   void GLGuiPushButton::init()
   {
-    this->setClassID(CL_GLGUI_PUSHBUTTON, "GLGuiPushButton");
+    this->registerObject(this, GLGuiPushButton::_objectList);
   }
 
Index: trunk/src/lib/gui/gl/glgui_pushbutton.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_pushbutton.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_pushbutton.h	(revision 9869)
@@ -21,5 +21,5 @@
   class GLGuiPushButton : public GLGuiButton
   {
-
+    ObjectListDeclaration(GLGuiPushButton);
   public:
     GLGuiPushButton(const std::string& label = "");
Index: trunk/src/lib/gui/gl/glgui_slider.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_slider.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_slider.cc	(revision 9869)
@@ -23,5 +23,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiSlider);
   /**
    * @brief standard constructor
@@ -46,5 +46,5 @@
   {
 
-    this->setClassID(CL_GLGUI_SLIDER, "GLGuiSlider");
+    this->registerObject(this, GLGuiSlider::_objectList);
 
     this->setClickable(true);
Index: trunk/src/lib/gui/gl/glgui_slider.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_slider.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_slider.h	(revision 9869)
@@ -21,5 +21,5 @@
   class GLGuiSlider : public GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiSlider);
   public:
     GLGuiSlider();
Index: trunk/src/lib/gui/gl/glgui_table.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_table.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_table.cc	(revision 9869)
@@ -23,4 +23,5 @@
 namespace OrxGui
 {
+  ObjectListDefinition(GLGuiTable);
   /**
    * @brief standard constructor
@@ -47,5 +48,5 @@
   void GLGuiTable::init()
   {
-    this->setClassID(CL_GLGUI_TABLE, "GLGuiTable");
+    this->registerObject(this, GLGuiTable::_objectList);
 
     this->setBorderTop(10);
Index: trunk/src/lib/gui/gl/glgui_table.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_table.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_table.h	(revision 9869)
@@ -25,5 +25,5 @@
   class GLGuiTable : public OrxGui::GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiTable);
   public:
     GLGuiTable(unsigned int rows, unsigned int columns);
Index: trunk/src/lib/gui/gl/glgui_text.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_text.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_text.cc	(revision 9869)
@@ -22,4 +22,5 @@
 namespace OrxGui
 {
+  ObjectListDefinition(GLGuiText);
   /**
    * standard constructor
@@ -43,5 +44,5 @@
   void GLGuiText::init()
   {
-    this->setClassID(CL_GLGUI_TEXT, "GLGuiText");
+    this->registerObject(this, GLGuiText::_objectList);
 
     this->_text.setParent2D(this);
Index: trunk/src/lib/gui/gl/glgui_text.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_text.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_text.h	(revision 9869)
@@ -20,5 +20,5 @@
   class GLGuiText : public GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiText);
   public:
     GLGuiText();
Index: trunk/src/lib/gui/gl/glgui_textfield.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_textfield.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_textfield.cc	(revision 9869)
@@ -22,4 +22,5 @@
 namespace OrxGui
 {
+  ObjectListDefinition(GLGuiTextfield);
   /**
    * standard constructor
@@ -43,5 +44,5 @@
   void GLGuiTextfield::init()
   {
-    this->setClassID(CL_GLGUI_TEXTFIELD, "GLGuiTextfield");
+    this->registerObject(this, GLGuiTextfield::_objectList);
 
     this->_text.setParent2D(this);
Index: trunk/src/lib/gui/gl/glgui_textfield.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_textfield.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_textfield.h	(revision 9869)
@@ -20,5 +20,5 @@
   class GLGuiTextfield : public GLGuiWidget
   {
-
+    ObjectListDeclaration(GLGuiTextfield);
   public:
     GLGuiTextfield();
Index: trunk/src/lib/gui/gl/glgui_widget.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_widget.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_widget.cc	(revision 9869)
@@ -25,11 +25,9 @@
 
 #include "loading/load_param.h"
-
-/// TODO TAKE THIS OUT OF HERE
 #include "loading/resource_manager.h"
 
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiWidget);
   /**
    * @brief standard constructor
@@ -95,5 +93,5 @@
   void GLGuiWidget::init()
   {
-    this->setClassID(CL_GLGUI_WIDGET, "GLGuiWidget");
+    this->registerObject(this, GLGuiWidget::_objectList);
 
     this->_focusable = false;
@@ -104,5 +102,5 @@
 
     if(GLGuiWidget::_defaultFont == NULL)
-      GLGuiWidget::_defaultFont = new Font(ResourceManager::getInstance()->getDataDir() + "/fonts/final_frontier.ttf", 20);
+      GLGuiWidget::_defaultFont = new Font(Resources::ResourceManager::getInstance()->mainGlobalPath().name() + "/fonts/final_frontier.ttf", 20);
 
     this->_font = *GLGuiWidget::_defaultFont;
Index: trunk/src/lib/gui/gl/glgui_widget.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_widget.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_widget.h	(revision 9869)
@@ -21,5 +21,4 @@
 namespace OrxGui
 {
-
   class GLGuiCursor;
 
@@ -31,4 +30,5 @@
   class GLGuiWidget : public Element2D
   {
+    ObjectListDeclaration(GLGuiWidget);
   public:
     GLGuiWidget(GLGuiWidget* parent = NULL);
Index: trunk/src/lib/gui/gl/glgui_window.cc
===================================================================
--- trunk/src/lib/gui/gl/glgui_window.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_window.cc	(revision 9869)
@@ -20,5 +20,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiWindow);
   /**
    * standard constructor
@@ -43,5 +43,5 @@
   void GLGuiWindow::init()
   {
-    this->setClassID(CL_GLGUI_WINDOW, "GLGuiWindow");
+    this->registerObject(this, GLGuiWindow::_objectList);
 
   }
Index: trunk/src/lib/gui/gl/glgui_window.h
===================================================================
--- trunk/src/lib/gui/gl/glgui_window.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glgui_window.h	(revision 9869)
@@ -20,5 +20,5 @@
   class GLGuiWindow : public GLGuiContainer
   {
-
+    ObjectListDeclaration(GLGuiWindow);
   public:
     GLGuiWindow();
Index: trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc
===================================================================
--- trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.cc	(revision 9869)
@@ -24,7 +24,9 @@
 #include "util/loading/factory.h"
 #include "util/loading/load_param.h"
-
-CREATE_FACTORY(GLMenuImageScreen, CL_GLMENU_IMAGE_SCREEN);
-
+#include "debug.h"
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(GLMenuImageScreen, CL_GLMENU_IMAGE_SCREEN);
+CREATE_FACTORY(GLMenuImageScreen);
 
 /**
@@ -33,5 +35,5 @@
 GLMenuImageScreen::GLMenuImageScreen(const TiXmlElement* root)
 {
-  this->setClassID(CL_GLMENU_IMAGE_SCREEN, "GLMenuImageScreen");
+  this->registerObject(this, GLMenuImageScreen::_objectList);
   this->setName("GLMenuLoadScreen");
   // Select Our VU Meter Background Texture
@@ -58,17 +60,17 @@
 {
   LoadParam(root, "BackgroundImage", this, GLMenuImageScreen, setBackgroundImage)
-    .describe("sets the image to load onto the loadscreen");
+  .describe("sets the image to load onto the loadscreen");
 
   LoadParam(root, "BackgroundPS", this, GLMenuImageScreen, setPosScale)
-    .describe("The Position and Scale of the Background Image in %(0-1.0). PosX, PosY, SizeX, SizeY");
+  .describe("The Position and Scale of the Background Image in %(0-1.0). PosX, PosY, SizeX, SizeY");
 
   LoadParam(root, "BarImage", this, GLMenuImageScreen, setBarImage)
-    .describe("sets the image of the LoadingBar");
+  .describe("sets the image of the LoadingBar");
 
   LoadParam(root, "BarPS", this, GLMenuImageScreen, setBarPosScale)
-    .describe("The Position and Scale of the Loading Bar in %(0-1.0). PosX, PosY, SizeX, SizeY");
+  .describe("The Position and Scale of the Loading Bar in %(0-1.0). PosX, PosY, SizeX, SizeY");
 
   LoadParam(root, "ElementCount", this, GLMenuImageScreen, setMaximum)
-    .describe("The Count of elements to load into the bar (this is only a maximum value)");
+  .describe("The Count of elements to load into the bar (this is only a maximum value)");
 }
 
Index: trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.h
===================================================================
--- trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.h	(revision 9682)
+++ trunk/src/lib/gui/gl/glmenu/glmenu_imagescreen.h	(revision 9869)
@@ -15,5 +15,5 @@
 class GLMenuImageScreen : public BaseObject
 {
-
+  ObjectListDeclaration(GLMenuImageScreen);
 public:
   GLMenuImageScreen (const TiXmlElement* root = NULL);
@@ -33,5 +33,5 @@
   void setMaximum (int maxValue);
   /** @returns the maximum of countable steps*/
-  inline int GLMenuImageScreen::getMaximum() const { return this->maxValue; };
+  inline int getMaximum() const { return this->maxValue; };
 
   void setValue (int currentValue);
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.cc
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 9682)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.cc	(revision 9869)
@@ -23,5 +23,5 @@
 namespace OrxGui
 {
-
+  ObjectListDefinition(GLGuiNotifier);
   /**
    * @brief standard constructor
@@ -29,5 +29,5 @@
   GLGuiNotifier::GLGuiNotifier ()
   {
-    this->setClassID(CL_GLGUI_NOTIFIER, "GLGuiNotifier");
+    this->registerObject(this, GLGuiNotifier::_objectList);
 
     // Element2D and generals
Index: trunk/src/lib/gui/gl/specials/glgui_notifier.h
===================================================================
--- trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 9682)
+++ trunk/src/lib/gui/gl/specials/glgui_notifier.h	(revision 9869)
@@ -24,4 +24,5 @@
   class GLGuiNotifier : public GLGuiWidget
   {
+    ObjectListDeclaration(GLGuiNotifier);
   public:
     GLGuiNotifier();
@@ -67,5 +68,6 @@
       MultiLineText*    text;
 
-    } DisplayLine;
+    }
+    DisplayLine;
 
 
Index: trunk/src/lib/gui/gui.cc
===================================================================
--- trunk/src/lib/gui/gui.cc	(revision 9682)
+++ trunk/src/lib/gui/gui.cc	(revision 9869)
@@ -18,5 +18,5 @@
 #include "gui.h"
 #include "gui_saveable.h"
-#include "preferences.h"
+#include "parser/preferences/preferences.h"
 
 namespace OrxGui
Index: trunk/src/lib/gui/gui_saveable.cc
===================================================================
--- trunk/src/lib/gui/gui_saveable.cc	(revision 9682)
+++ trunk/src/lib/gui/gui_saveable.cc	(revision 9869)
@@ -18,5 +18,5 @@
 #include "gui_saveable.h"
 #include "gui.h"
-#include "preferences.h"
+#include "parser/preferences/preferences.h"
 
 #include "debug.h"
Index: trunk/src/lib/lang/Makefile.am
===================================================================
--- trunk/src/lib/lang/Makefile.am	(revision 9682)
+++ trunk/src/lib/lang/Makefile.am	(revision 9869)
@@ -1,7 +1,5 @@
-MAINSRCDIR=../..
-include $(MAINSRCDIR)/defs/include_paths.am
-
-LIB_PREFIX=$(MAINSRCDIR)/lib
-include $(MAINSRCDIR)/lib/BuildLibs.am
+INCLUDES = -I../..
+INCLUDES +=-I..
+INCLUDES +=-I../util
 
 noinst_LIBRARIES = libORXlang.a
@@ -9,33 +7,9 @@
 libORXlang_a_SOURCES = \
 		base_object.cc \
-		class_list.cc \
-		new_class_id.cc \
-		new_object_list.cc
+		class_id.cc \
+		object_list.cc
 
 noinst_HEADERS = \
 		base_object.h \
-		class_list.h \
-		new_class_id.h \
-		new_object_list.h
-
-
-
-
-
-## THIS ALL IS JUST FOR TESTING!!
-check_PROGRAMS = test_object_list
-
-test_object_list_SOURCES = \
-		test_object_list.cc
-
-test_object_list_DEPENDENCIES = libORXlang.a
-
-test_object_list_LDADD = \
-		$(MAINSRCDIR)/util/libORXutils.a \
-		$(libORXlibs_a_LIBRARIES_) \
-		$(MAINSRCDIR)/world_entities/libORXwe.a \
-		$(libORXlibs_a_LIBRARIES_) \
-		$(MAINSRCDIR)/util/libORXutils.a
-
-#test_object_list_LDADD = \
-		libORXlang.a
+		class_id.h \
+		object_list.h
Index: trunk/src/lib/lang/base_object.cc
===================================================================
--- trunk/src/lib/lang/base_object.cc	(revision 9682)
+++ trunk/src/lib/lang/base_object.cc	(revision 9869)
@@ -1,4 +1,2 @@
-
-
 /*
    orxonox - the future of 3D-vertical-scrollers
@@ -19,21 +17,20 @@
 #include "base_object.h"
 
+#include "util/debug.h"
 #include "util/loading/load_param.h"
-#include "class_list.h"
+
+ObjectListDefinition(BaseObject);
 
 /**
  * @brief sets the name from a LoadXML-Element
- * @param root the element to load from
+ * @param objectName: The name of the Object.
  */
 BaseObject::BaseObject(const std::string& objectName)
 {
-  this->classID = CL_BASE_OBJECT;
   this->className = "BaseObject";
 
   this->objectName = objectName;
-  this->classList = NULL;
   this->xmlElem = NULL;
-
-  //ClassList::addToClassList(this, this->classID, "BaseObject");
+  this->registerObject(this, BaseObject::_objectList);
 }
 
@@ -43,5 +40,14 @@
 BaseObject::~BaseObject ()
 {
-  ClassList::removeFromClassList(this);
+  /// Remove from the ObjectLists
+  ClassEntries::iterator it;
+  PRINTF(5)("Deleting Object of type %s::%s\n", this->getClassCName(), getCName());
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+  {
+    if (ORX_DEBUG >= 5)
+      assert((*it)._objectList->checkIteratorInList((*it)._iterator) || (*it)._objectList->checkObjectInList(this));
+    (*it)._objectList->unregisterObject((*it)._iterator);
+    delete (*it)._iterator;
+  }
 
   if (this->xmlElem != NULL)
@@ -69,22 +75,4 @@
 
 /**
- * @brief sets the class identifiers
- * @param id a number for the class from class_id.h enumeration
- * @param className the class name
-*/
-void BaseObject::setClassID(ClassID classID, const std::string& className)
-{
-  //printf("%s(0x%.8X)->%s(0x%.8X)\n", this->className, this->classID, className, classID);
-  assert (!(this->classID & classID & !CL_MASK_SUBSUPER_CLASS_IDA ));
-
-  this->leafClassID = classID;
-  this->classID |= (long)classID;
-  this->className = className;
-
-  this->classList = ClassList::addToClassList(this, classID, this->classID, className);
-}
-
-
-/**
  * @brief set the name of the Object
  * @param objectName The new name of the Object.
@@ -97,71 +85,74 @@
 
 /**
- * @brief queries for the ClassID of the Leaf Class (the last made class of this type
- * @returns the ClassID of the Leaf Class (e.g. the ID of the Class)
- *
- * the returned ID can be used to generate new Objects of the same type through
- * Factory::fabricate(Object->getLeafClassID());
+ * @brief Seeks in the Inheritance if it matches objectList.
+ * @param objectList The ObjectList this should be a member of (by Pointer-comparison).
+ * @return True if found, false if not.
  */
-const ClassID& BaseObject::getLeafClassID() const
+bool BaseObject::isA(const ObjectListBase& objectList) const
 {
-  return this->leafClassID;
-}
-
-
-
-/**
- * @brief checks if the class is a classID
- * @param classID the Identifier to check for
- * @returns true if it is, false otherwise
-*/
-bool BaseObject::isA (ClassID classID) const
-{
-  // if classID is a derivable object from a SUPERCLASS
-  if (classID & CL_MASK_SUPER_CLASS)
-  {
-    if( likely(this->classID & classID))
+  ClassEntries::const_iterator it;
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+    if ((*it)._objectList == &objectList)
       return true;
-  }
-  // if classID is a SubSuperClass, and
-  else if (classID & CL_MASK_SUBSUPER_CLASS)
-  {
-    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_IDA) == (classID & CL_MASK_SUBSUPER_CLASS_IDA)) &&
-        this->classID & classID & CL_MASK_SUBSUPER_CLASS_IDB))
-      return true;
-  }
-  // if classID is a LOWLEVEL-class
-  else
-  {
-    if( likely((this->classID & CL_MASK_LOWLEVEL_CLASS) == classID))
-      return true;
-  }
   return false;
 }
 
 
+/**
+ * @brief Seeks in the Inheritance if it matches objectList.
+ * @param classID The ClassID this should be a member of (by Pointer-comparison).
+ * @return True if found, false if not.
+ */
+bool BaseObject::isA(const ClassID& classID) const
+{
+  ClassEntries::const_iterator it;
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+    if (*(*it)._objectList == classID)
+      return true;
+  return false;
+}
 
 /**
- * @brief checks if the class is a classID
- * @param classID the Identifier to check for
- * @returns true if it is, false otherwise
+ * @brief Seeks in the Inheritance if it matches objectList.
+ * @param classID The ClassID of the class this should be a member of.
+ * @return True if found, false if not.
  */
-bool BaseObject::isA (const std::string& className) const
+bool BaseObject::isA(int classID) const
 {
-  ClassID classID = ClassList::StringToID(className);
-  if (classID != CL_NULL)
-    return this->isA(classID);
-  else
-    return false;
+  ClassEntries::const_iterator it;
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+    if (*(*it)._objectList == classID)
+
+      return true;
+  return false;
+}
+
+/**
+ * @brief Seeks in the Inheritance if it matches objectList.
+ * @param className The ClassName of the class this should be a member of.
+ * @return True if found, false if not.
+ */
+bool BaseObject::isA(const std::string& className) const
+{
+  ClassEntries::const_iterator it;
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+    if (*(*it)._objectList == className)
+      return true;
+  return false;
 }
 
 
 /**
- * @brief compares the ObjectName with an external name
- * @param objectName: the name to check.
- * @returns true on match, false otherwise.
+ * @brief This is for debug purposes, to see the Inheritances of this Object and its classes.
+ *
+ * The Inheritance will be listed in a Linear fashion, diamand structures are resolved in a linear dependency.
  */
-bool BaseObject::operator==(const std::string& objectName) const
+void BaseObject::listInheritance() const
 {
-  return (this->objectName == objectName);
+  PRINT(0)("Listing inheritance diagram for %s::%s: ", getClassCName(), getCName());
+  ClassEntries::const_iterator it;
+  for (it = this->_classes.begin(); it != this->_classes.end(); ++it)
+    PRINT(0)(" -> %s(id:%d)", (*it)._objectList->name().c_str(), (*it)._objectList->id());
+  PRINT(0)("\n");
+
 }
-
